/**
 * Get bounding client rect of given element
 */
export declare function getBoundingClientRect(element: HTMLElement): ClientRect & {
    middle: number;
    center: number;
};
/**
 * Set all styles from provided object to the element
 */
export declare function style(el: HTMLElement, styles: object): void;
/**
 * Get vendors property
 */
export declare function getVendorProperty(property: string): string[];
/**
 * Assign style property to element with all possible vendor prefixes.
 */
export declare function setVendorStyle(element: HTMLElement, property: string, value: any): void;
/**
 * Checkes if DOM can be access in current environment
 */
export declare function canUseDOM(): boolean;
/**
 * Checks if context contains node in the DOM tree
 * @see https://github.com/react-bootstrap/dom-helpers/blob/master/src/query/contains.js
 */
export declare const contains: (context: Node, node: Node) => boolean;
