"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.raf = function (cb) {
    var id;
    var invoke = function (ctx, args) { return function () {
        id = undefined;
        cb.apply(ctx, args);
    }; };
    //use function to save original context
    function synced() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (typeof id === 'undefined') {
            id = requestAnimationFrame(invoke(this, args));
        }
    }
    synced['cancel'] = function () {
        if (id) {
            cancelAnimationFrame(id);
        }
    };
    return synced;
};
//# sourceMappingURL=raf.js.map