import { Omit } from 'typelevel-ts';
/**
 * Generates new object with keys mapped with template
 */
export declare function mapKeys<T extends {}>(object: T, template: (key: string) => string): T;
/**
 * Deeply compares two objects
 * @param {*} objA
 * @param {*} objB
 * @returns {Boolean}
 */
export declare function deepEqual(objA: object, objB: object): boolean;
export declare type PartialKeys<T extends {}, K extends keyof T> = Omit<T, K> & Partial<Pick<T, K>>;
export declare const isNotNullable: <T>(value: T | null | undefined) => value is T;
