"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Option_1 = require("fp-ts/lib/Option");
var function_1 = require("fp-ts/lib/function");
function localStorageClient(R, M) {
    return R.asks(function (e) {
        var storageEvent = M.fromEvent(e.window, 'storage');
        return {
            getItem: function (key, codec, defaultValue) {
                var initial = Option_1.getOrElse(function () { return defaultValue; })(getValue(e.localStorage.getItem(key), codec));
                var value = M.filterMap(storageEvent, function (e) { return (e.key !== key ? Option_1.none : getValue(e.newValue, codec)); });
                var _a = M.createAdapter(), nextLocal = _a[0], local = _a[1];
                var next = function (value) {
                    try {
                        e.localStorage.setItem(key, JSON.stringify(codec.encode(value)));
                        nextLocal(value);
                    }
                    catch (_a) { }
                };
                return [next, M.alt(M.alt(value, function_1.constant(M.of(initial))), function_1.constant(local))];
            },
        };
    });
}
exports.localStorageClient = localStorageClient;
var getValue = function (value, codec) {
    if (value === null) {
        return Option_1.none;
    }
    try {
        return Option_1.fromEither(codec.decode(JSON.parse(value)));
    }
    catch (_a) {
        return Option_1.none;
    }
};
//# sourceMappingURL=local-storage.js.map